/**
 *SSO App
 * Defined UNAS 3.0 SSO manager
 */
var SSOApp = SSOApp || {}; //Define App namespace, if you want.
/**
 *Constructor UNAS App
 */
SSOApp.App = function() {
  this.id = 'SSO Server';
  this.name = 'SSO Server';
  this.version = '6.0.1';
  this.active = false;
  this.menuIcon = '/apps/ssoserver/images/logo.png?v=6.0.1&';
  this.shortcutIcon = '/apps/ssoserver/images/logo.png?v=6.0.1&';
  this.entryUrl = '/apps/ssoserver/sso.html?v=6.0.1&';
  //this.entryHelpUrl = '/apps/sso/sso_help.html';
  var self = this;
  this.SSOAppWindow = function() { //create app window
    if (UNAS.CheckAppState('SSO Server')) {
      return false;
    }
    self.window = new MUI.Window({
      id: 'SSOAppWindow',
      title: UNAS._('SSO Server'),
      icon: '/apps/ssoserver/images/logo_small.png?v=6.0.1&',
      loadMethod: 'xhr',
      width: 770,
      height: 500,
      maximizable: false,
      resizable: true,
      scrollbars: false,
      contentURL: '/apps/ssoserver/sso.html?v=6.0.1&',
      require: {
        css: ['/apps/ssoserver/css/sso.css?v=6.0.1']
      },
      onBeforeBuild: function() {
        UNAS.SetAppOpenedWindow("SSO Server", 'SSOAppWindow');
      }
    });
  };
  this.SSOUninstall = function() {
    UNAS.RemoveDesktopShortcut('SSO Server');
    UNAS.RemoveMenu('SSO Server');
    UNAS.RemoveAppFromGroups('SSO Server', 'ControlPanel');
    UNAS.RemoveAppFromGroups('SSO Server', 'Help');
    UNAS.RemoveAppFromApps('SSO Server');
  };
  new UNAS.Menu('UNAS_ControlPanel_Account_Menu', this.name, this.menuIcon, 'SSO Server', '', this.SSOAppWindow);
  //new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'SSO', this.SSOAppWindow);
  new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {
    'Type': 'Account',
    'Location': 4,
    "Icon": this.shortcutIcon,
    "Url": this.entryUrl
  }, {});
  var OnChangeLanguage = function(e) {
    UNAS.SetMenuTitle('SSO Server', UNAS._('SSO Server')); //translate menu
    //UNAS.SetShortcutTitle('SSO', UNAS._('User Account'));
    if (typeof self.window !== 'undefined') {
      UNAS.SetWindowTitle('SSOAppWindow', UNAS._('SSO Server'));
    }
  };
  UNAS.LoadTranslation('/apps/ssoserver/languages/Translation?v=' + this.version, OnChangeLanguage);
  UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
  UNAS.CreateApp(this.name, this.shortcutIcon, this.SSOAppWindow, this.SSOUninstall);
};

new SSOApp.App();
