function addApplication() {
  var addAppWindow = new MUI.Modal({
    id: 'addAppWindow',
    title: UNAS._('##$@sso@$##Add##$@sso@$##'),
    modal: true,
    width: 650,
    height: 230,
    modalOverlayClose: false,
    contentURL: '/apps/ssoserver/addapp.html?v=6.0.1'
  });
}

function editApplication(data) {
  var editAppWindow = new MUI.Modal({
    id: 'editAppWindow',
    title: UNAS._('##$@sso@$##Edit##$@sso@$##'),
    modal: true,
    width: 650,
    height: 230,
    data: data,
    modalOverlayClose: false,
    contentURL: '/apps/ssoserver/editapp.html?v=6.0.1'
  });
}

function ssotabsel() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);
  var i = that.index();
  that.attr('class', 'unas_tab_sel').siblings().attr('class', 'unas_tab');
  jQuery('.pagemodule').eq(i).show().siblings('.pagemodule').hide();
}

function sso_settings_load() {
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    data: JSON.stringify({
      cmd: "sso_settings_load",
      token: UToken
    }),
    success: function(res) {
      if (res.err == 0) {
        var info = res.results || {};
        jQuery('#jv-defaultports').prop('checked', info.defaultports);
        jQuery('#jv-httpport-sel').prop('checked', info.usehttp);
        jQuery('#jv-httpport-val').val(info.httpport || "");
        jQuery('#jv-httpsport-sel').prop('checked', info.usehttps);
        jQuery('#jv-httpsport-val').val(info.httpsport || "");
        jQuery('#jv-localusers').prop('checked', info.localusers);
        jQuery('#jv-aduser').prop('checked', info.adusers);
        jQuery('#jv-pagetitle').val(info.pagetitle || "");

        if (info.defaultports) {
          jQuery('#jv-http-item input').prop('disabled', true);
        } else {
          jQuery('#jv-http-item input').prop('disabled', false);
        }

      } else {

      }
    },
    error: function() {}
  });
}

function sso_settings_save() {

  var defaultports = jQuery('#jv-defaultports').prop('checked') ? 1 : 0;
  var usehttp = jQuery('#jv-httpport-sel').prop('checked') ? 1 : 0;
  var httpport = +jQuery('#jv-httpport-val').val() || 0;
  var usehttps = jQuery('#jv-httpsport-sel').prop('checked') ? 1 : 0;
  var httpsport = +jQuery('#jv-httpsport-val').val() || 0;
  var localusers = jQuery('#jv-localusers').prop('checked') ? 1 : 0;
  var adusers = jQuery('#jv-aduser').prop('checked') ? 1 : 0;
  var pagetitle = jQuery('#jv-pagetitle').val();

  if (!defaultports) {
    if (!usehttp && !usehttps) {
      alert(UNAS._('Please select the enabled port!'));
      return;
    }

    if ((usehttp && httpport == '') || (usehttps && httpsport == '')) {
      alert(UNAS._('Port must be 1~65535！'));
      return;
    }

  }

  if (pagetitle == "") {
    alert(UNAS._('SSO login title cannot be empty!'));
    return;
  }

  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    data: JSON.stringify({
      cmd: "sso_settings_save",
      token: UToken,
      params: {
        defaultports: defaultports,
        usehttp: usehttp,
        httpport: httpport,
        usehttps: usehttps,
        httpsport: httpsport,
        localusers: localusers,
        adusers: adusers,
        pagetitle: pagetitle
      }
    }),
    success: function(res) {

      if (res.err == 0) {
        sso_settings_load();
      } else if (res.err == 9982) {
        alert(UNAS._('Port has been used!'));
      } else if (res.err == 9997) {
        alert(UNAS._('Please choose the login authentication method!'));
      } else if (res.err == 9928) {
        alert(UNAS._('SSO login title cannot be empty!'));
      } else {
        alert(UNAS._('Operation Failed'));
      }

    },
    error: function() {}
  });
}

function ssoAppidAlload() {
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    data: JSON.stringify({
      cmd: "sso_appid_alload",
      token: UToken
    }),
    success: function(res) {

      if (res.err == 0) {
        var info = res.results || {};
        var records = info.records || [];
        jQuery('#jv-sso-apps-host').empty();
        for (var i = 0; i < records.length; i++) {
          var appinfo = records[i];
          var appdom = ssoTemplateAppend('#jv-sso-apps-host', 'jvt-appstr', 'jvt-appstr' + i);
          appdom.data('appinfo', appinfo);
          appdom.find('.appsname_sso').text(appinfo.name || '--');
          appdom.find('.redirect_uri_sso').text(appinfo.redirect || '--');
          appdom.find('.appid_sso').text(appinfo.appid || '--');

          appdom.find('.jvc-editapp').data('appinfo', appinfo).on('click', function() {
            var data = jQuery(this).data('appinfo');
            editApplication(data);
          });

          appdom.find('.jvc-editapp').on('mouseenter', function() {
            jQuery(this).attr('title', UNAS._('##$@sso@$##Edit##$@sso@$##'));
          })

          appdom.find('.jvc-deleteapp').attr('name', appinfo.name).on('click', function() {
            var name = jQuery(this).attr('name');
            sso_alertWindowFn({
              'tips': UNAS._('Are you sure you want to delete it?')
            }, function() {
              deleteApplication(name);
            })
          });

          appdom.find('.jvc-deleteapp').on('mouseenter', function() {
            jQuery(this).attr('title', UNAS._('##$@sso@$##Delete##$@sso@$##'));
          })

          // appdom.find('input[name="ssoapp"]').on('click', function() {
          //   var len = jQuery('#jv-sso-apps-host input[name="ssoapp"]').length;
          //   var checked_len = jQuery('#jv-sso-apps-host input[name="ssoapp"]:checked').length;
          //
          //   if (this.checked) {
          //     jQuery('#jv-deleteappbtn').attr('class', 'unas_button_content');
          //   } else {
          //     if (checked_len) {
          //       jQuery('#jv-deleteappbtn').attr('class', 'unas_button_content');
          //     } else {
          //       jQuery('#jv-deleteappbtn').attr('class', 'unas_button_content_disabled');
          //     }
          //   }
          //   if (checked_len == len) {
          //     jQuery('#jv-appall ').prop('checked', true);
          //   } else {
          //     jQuery('#jv-appall ').prop('checked', false);
          //   }
          //
          // })

        }

      } else {

      }
    }
  });
}


function deleteApplication(name) {

  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    data: JSON.stringify({
      cmd: "sso_appid_remove",
      token: UToken,
      params: {
        name: name
      }
    }),
    success: function(res) {

      if (res.err == 0) {
        ssoAppidAlload();
      } else {
        sso_alertWindowFn({
          'tips': UNAS._('Operation Failed')
        });
      }
    }
  });

}

function sso_alertWindowFn(data, fn) {
  var url = '/apps/ssoserver/alert.html?=v=6.0.1&'
  var alertWindow = new MUI.Modal({
    id: 'jv-alertWindow',
    title: UNAS._(data.title || 'Tip'),
    modal: true,
    modalOverlayClose: false,
    width: 380,
    height: 200,
    data: data,
    contentURL: url
  });
  alertWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function searchappitem(e) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var t = event.target;
  if (e) {
    t = e;
  }
  var v = jQuery(t).val().trim();
  jQuery("#jv-sso-apps-host tr:contains(" + v + ")").show();
  jQuery("#jv-sso-apps-host tr:not(:contains(" + v + "))").hide();
}

function ssoTemplateAppend(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
  var tagName = '#' + name;
  return jQuery(tagName);
};

(function() {

  jQuery('#jv-defaultports').on('click', function() {
    if (this.checked) {
      jQuery('#jv-http-item input').prop('disabled', true);
    } else {
      jQuery('#jv-http-item input').prop('disabled', false);
    }
  })

  jQuery('#jv-appall').on('click', function() {
    if (this.checked) {
      jQuery('#jv-sso-apps-host input[name="ssoapp"]').prop('checked', true);
      jQuery('#jv-deleteappbtn').attr('class', 'unas_button_content');
    } else {
      jQuery('#jv-sso-apps-host input[name="ssoapp"]').prop('checked', false);
      jQuery('#jv-deleteappbtn').attr('class', 'unas_button_content_disabled');
    }
  })

  ssoAppidAlload();
  sso_settings_load();
})();
